﻿Module Module1

    '// 此例程是控制采集卡模拟输入通道，单通道单点采集，每次得到一个点的数据。
    '// 此例程适用型号：
    '// PCI-225x
    '// PCI-3xxx
    '// PCI-5xxx

    Sub Main()

        Dim DevIndex As Integer = 0
        Dim rst As Integer
        Dim AiValue As Single

        '// 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        '// 设置 Ai 采集模式为单点采集
        rst = SetAiSampleMode(DevIndex, 0)
        If (rst < 0) Then Return

        '// 设置 Ai 量程 1。
        '// 对于 PCI-225x/5000 系列，函数中最后一个参数 0 无意义。
        '// 对于 PCI-3000 系列，此处指定设置通道 0 的量程
        rst = SetAiRange(DevIndex, 1, 0)
        If (rst < 0) Then Return

        '// 设置 Ai 接线方式为 RSE
        rst = SetAiConnectType(DevIndex, 0)
        If (rst < 0) Then Return

        '// 读取模拟输入单点采集结果。
        '// 此处读取通道 0
        rst = GetAiOnePoint(DevIndex, 0, AiValue)
        If (rst < 0) Then Return

        Console.WriteLine("AiValue = {0}", AiValue)

        '// 关闭设备
        rst = CloseDevice(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
