﻿Module Module1

    ' 此例程控制采集卡输出无限不循环的模拟任意波信号。
    ' 此例程适用型号：
    ' PCI-2253
    ' PCI-31xx

    Sub Main()

        Dim rst As Integer
        Dim DevIndex As Integer = 0
        Dim i As Integer
        Dim j As Integer
        Dim WaveData As Single

        ' 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        ' 清空 Ao 0 波形 FIFO
        rst = ClearAoFifo(DevIndex, 0)
        If (rst < 0) Then Return

        ' 设置 Ao 0 输出为 无限不循环 模式
        rst = SetAoMode(DevIndex, 0, 2)
        If (rst < 0) Then Return

        ' 设置 Ao 0 输出采样率
        ' 此处设置为 100000ns，即 10kS/s
        rst = SetAoSamplePeriod(DevIndex, 0, 100000)
        If (rst < 0) Then Return

        ' 设置 Ao 0 触发源，Ao 0 软件触发
        rst = SetAoTrigSource(DevIndex, 0, 2)
        If (rst < 0) Then Return

        ' 先发送 1000 点波形数据到硬件中
        For i = 0 To 999 Step 1
            WaveData = Rnd()
            rst = SetAoFifo(DevIndex, 0, WaveData)
            If (rst < 0) Then Return
        Next i

        ' 设置 Ao 准备完成，AoReady
        rst = AoReady(DevIndex, 0, 1)
            If (rst < 0) Then Return

            ' 发出 Ao 0 软件触发命令
            rst = SetAoSoftTrig(DevIndex, 0)
            If (rst < 0) Then Return

        ' 开始发送不循环的波形数据到硬件
        ' 此处仅发送 10 次作为范例
        For i = 0 To 9 Step 1
            ' 再发送 1000 点波形数据到硬件中
            For j = 0 To 999 Step 1
                WaveData = Rnd()
                rst = SetAoFifo(DevIndex, 0, WaveData)
                If (rst < 0) Then Return
            Next j

            Console.WriteLine("send 1000 points to device. times: {0}", i)

            ' 每隔 100ms 发送 1000 点波形数据到硬件中
            ' 保证硬件 FIFO 中有足够的数据，但又不溢出
            System.Threading.Thread.Sleep(100)
        Next i

        ' 清除 Ao 0 软件触发标志
        rst = ClearAoSoftTrig(DevIndex, 0)
        If (rst < 0) Then Return

        ' 清除 Ao 0 准备完成标志
        rst = AoReady(DevIndex, 0, 0)
        If (rst < 0) Then Return

        ' 关闭设备
        rst = CloseDevice(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
