﻿Module Module1

    ' 此例程控制采集卡模拟输出通道，输出指定次数的任意波信号。
    ' 此例程适用型号：
    ' PCI-2253
    ' PCI-31xx

    Sub Main()

        Dim rst As Integer
        Dim DevIndex As Integer = 0
        Dim i As Integer
        Dim WaveData(100) As Single

        ' 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        ' 清空 Ao 0 波形 FIFO
        rst = ClearAoFifo(DevIndex, 0)
        If (rst < 0) Then Return

        ' 设置 Ao 0 输出为 n-cycle 模式
        rst = SetAoMode(DevIndex, 0, 1)
        If (rst < 0) Then Return

        ' 设置 Ao 0 输出采样率
        ' 此处设置为 100000ns，即 10kS/s
        rst = SetAoSamplePeriod(DevIndex, 0, 100000)
        If (rst < 0) Then Return

        ' 设置 Ao 0 输出波形次数
        ' 此处输出 10 次。如果设置为 0，表示无限循环输出
        rst = SetAoNCycleCount(DevIndex, 0, 10)
        If (rst < 0) Then Return

        ' 设置 Ao 0 触发源，Ao 0 软件触发
        rst = SetAoTrigSource(DevIndex, 0, 2)
        If (rst < 0) Then Return

        ' 生成 100 点的波形数据
        For i = 0 To 99 Step 1
            WaveData(i) = i / 100 * 5
        Next i

        ' 设置 Ao 0 波形数据
        ' 将 100 个点的波形数据写入到硬件
        For i = 0 To 99 Step 1
            rst = SetAoFifo(DevIndex, 0, WaveData(i))
            If (rst < 0) Then Return
        Next i

        ' 设置 Ao 准备完成，AoReady
        rst = AoReady(DevIndex, 0, 1)
        If (rst < 0) Then Return

        ' 发出 Ao 0 软件触发命令
        rst = SetAoSoftTrig(DevIndex, 0)
        If (rst < 0) Then Return

        ' 清除 Ao 0 软件触发标志
        rst = ClearAoSoftTrig(DevIndex, 0)
        If (rst < 0) Then Return

        ' 清除 Ao 0 准备完成标志
        rst = AoReady(DevIndex, 0, 0)
        If (rst < 0) Then Return

        ' 关闭设备
        rst = CloseDevice(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
