﻿Module Module1

    ' 此例程是控制采集卡数字输入通道连续采集
    ' 此例程适用型号：
    ' PCI-1132
    ' PCI-1316
    ' PCI-225x
    ' PCI-3xxx
    ' PCI-5xxx

    Sub Main()

        Dim rst As Integer
        Dim i As Integer
        Dim DevIndex As Integer = 0
        Dim DiValue(1000) As UInteger
        Dim DiFifoUsdw As UInteger

        ' 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        ' 设置数字 I/O 方向
        ' 由于 PCI-225x/3000/5000 的数字 I/O 可以设置为输入或者输出
        ' 此处全部设置为输入
        ' 其他数字 I/O 不支持设置的型号可以不用设置
        rst = SetDioDir(DevIndex, &H7FFFFFFF)
        If (rst < 0) Then Return

        ' 设置 Di 灵敏度
        rst = SetDiSensitivity(DevIndex, 20000)
        If (rst < 0) Then Return

        ' 设置 Di 采集模式为连续采集
        rst = SetDiSampleMode(DevIndex, 2)
        If (rst < 0) Then Return

        ' 设置 Di 采样周期，10000ns，即 100kS/s
        rst = SetDiSamplePeriod(DevIndex, 10000)
        If (rst < 0) Then Return

        ' 设置 Di 触发源，Di 软件触发
        rst = SetDiTrigSource(DevIndex, 1)
        If (rst < 0) Then Return

        ' 设置 Di 准备完成，DiReady
        rst = DiReady(DevIndex, 1)
        If (rst < 0) Then Return

        ' 发出 Di 软件触发命令
        rst = SetDiSoftTrig(DevIndex)
        If (rst < 0) Then Return

        ' 读取 Di 连续采集得到的数据
        ' 连续无间断采集数据，只需要循环调用 GetDiData 这个函数，
        ' 得到的数据即是连续无间断采集得到的数据，此处只循环 10 次作为范例
        For i = 0 To 9 Step 1
            rst = GetDiData(DevIndex, 1000, DiValue(0), DiFifoUsdw, 2000)
            If (rst < 0) Then Return
            Console.WriteLine("Call GetDiData times: {0}", i)
        Next i

        ' 清除 Di 软件触发标志
        rst = ClearDiSoftTrig(DevIndex)
        If (rst < 0) Then Return

        ' 清除 Di 准备完成标志
        rst = DiReady(DevIndex, 0)
        If (rst < 0) Then Return

        ' 关闭设备
        rst = CloseDevice(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
