﻿Module Module1

    ' 此例程是控制采集卡数字输入通道进行边沿计数
    ' 此例程适用型号：
    ' PCI-1132
    ' PCI-1316
    ' PCI-225x
    ' PCI-3xxx
    ' PCI-5xxx

    Sub Main()

        Dim rst As Integer
        Dim i As Integer
        Dim DevIndex As Integer = 0
        Dim DiCountValue As UInteger

        ' 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        ' 设置数字 I/O 方向
        ' 由于 PCI-225x/3000/5000 的数字 I/O 可以设置为输入或者输出
        ' 此处全部设置为输入
        ' 其他数字 I/O 不支持设置的型号可以不用设置
        rst = SetDioDir(DevIndex, &HFFFFFFFF)
        If (rst < 0) Then Return

        ' 设置 Di 灵敏度
        rst = SetDiSensitivity(DevIndex, 20000000)
        If (rst < 0) Then Return

        ' 设置 Di 计数边沿，设置为上升沿计数
        ' 参数每一 bit 对应一个 Di 通道
        ' 此处将 32 个通道全部设置为上升沿计数
        rst = SetDiCountEdge(DevIndex, &HFFFFFFFF)
        If (rst < 0) Then Return

        ' 使能 Di 计数功能
        rst = SetDiCountEn(DevIndex, 1)
        If (rst < 0) Then Return

        ' 将 Di 0 计数值归零
        rst = ClearDiCountValue(DevIndex, 0)
        If (rst < 0) Then Return

        System.Threading.Thread.Sleep(10)

        ' 读取 Di 计数器值
        ' 此处读取 10 次
        For i = 0 To 9 Step 1
            rst = GetDiCountValue(DevIndex, 0, DiCountValue)
            If (rst < 0) Then Return
            Console.WriteLine("Call GetDiCountVedalue {0} times. DiCountValue is: {1}", i + 1, DiCountValue)
            System.Threading.Thread.Sleep(1000)
        Next i

        ' 禁用 Di 计数功能
        rst = SetDiCountEn(DevIndex, 0)
        If (rst < 0) Then Return

        ' 关闭设备
        rst = CloseDevice(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
