﻿Module Module1

    ' 此例程是控制采集卡数字输入单点读取
    ' 此例程适用型号：
    ' PCI-1132
    ' PCI-1316
    ' PCI-225x
    ' PCI-3xxx
    ' PCI-5xxx

    Sub Main()

        Dim rst As Integer
        Dim DevIndex As Integer = 0
        Dim DiValue As UInteger

        ' 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        ' 设置数字 I/O 方向
        ' 由于 PCI-225x/3000/5000 的数字 I/O 可以设置为输入或者输出
        ' 此处全部设置为输入
        ' 其他数字 I/O 不支持设置的型号可以不用设置
        rst = SetDioDir(DevIndex, &HFFFFFFFF)
        If (rst < 0) Then Return

        ' 设置 Di 灵敏度
        rst = SetDiSensitivity(DevIndex, 20000)
        If (rst < 0) Then Return

        ' 读取 Di 状态
        rst = GetDiStatus(DevIndex, 0, DiValue)
        If (rst < 0) Then Return

        ' 关闭设备
        rst = CloseDevice(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("GetDiStatus Success. DiValue = 0x{0:X}", DiValue)
        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
