﻿Module Module1

    ' 此例程控制采集卡输出无限不循环的数字任意波信号。
    ' 此例程适用型号：
    ' PCI-1232
    ' PCI-1316
    ' PCI-225x
    ' PCI-3xxx

    Sub Main()

        Dim rst As Integer
        Dim DevIndex As Integer = 0
        Dim i, j As Integer
        Dim WaveData As UInteger

        ' 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        ' 设置数字 I/O 方向
        ' 此处将所有的数字 I/O 通道设置为输出
        ' 由于 PCI-225x/3000/5000 的数字 I/O 可以设置为输入或者输出
        ' 此处全部设置为输入
        ' 其他数字 I/O 不支持设置的型号可以不用设置
        rst = SetDioDir(DevIndex, &H0)
        If (rst < 0) Then Return

        ' 清空 Do 波形 FIFO
        rst = ClearDoFifo(DevIndex)
        If (rst < 0) Then Return

        ' 设置 Do 输出为 无限不循环模式
        rst = SetDoMode(DevIndex, 2)
        If (rst < 0) Then Return

        ' 设置 Do 输出采样率
        ' 此处设置为 100000ns，即 10kS/s
        rst = SetDoSamplePeriod(DevIndex, 100000)
        If (rst < 0) Then Return

        ' 设置 Do 触发源，Do 软件触发
        rst = SetDoTrigSource(DevIndex, 18)
        If (rst < 0) Then Return

        ' 先发送 1000 点波形数据到硬件中
        For i = 0 To 999 Step 1
            WaveData = Rnd() * &HFFFF
            rst = SetAoFifo(DevIndex, 0, WaveData)
            If (rst < 0) Then Return
        Next i

        ' 设置 Do 准备完成，DoReady
        rst = DoReady(DevIndex, 1)
            If (rst < 0) Then Return

            ' 发出 Do 软件触发命令
            rst = SetDoSoftTrig(DevIndex)
            If (rst < 0) Then Return

        ' 开始发送不循环的波形数据到硬件
        ' 此处仅发送 10 次作为范例
        For i = 0 To 9 Step 1
            ' 再发送 1000 点波形数据到硬件中
            For j = 0 To 999 Step 1
                WaveData = Rnd() * &HFFFF
                rst = SetDoFifo(DevIndex, WaveData)
                If (rst < 0) Then Return
            Next j

            ' 每隔 100ms 发送 1000 点波形数据到硬件中
            ' 保证硬件 FIFO 中有足够的数据，但又不溢出
            System.Threading.Thread.Sleep(100)

            Console.WriteLine("send 1000 points to device. times: {0}", i)
        Next i

        ' 清除 Do 软件触发标志
        rst = ClearDoSoftTrig(DevIndex)
        If (rst < 0) Then Return

        ' 清除 Do 准备完成标志
        rst = DoReady(DevIndex, 0)
        If (rst < 0) Then Return

        ' 关闭设备
        rst = CloseDevice(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
