﻿Module Module1

    ' 此例程控制采集卡数字输出通道，输出指定次数的任意波信号。
    ' 此例程适用型号：
    ' PCI-1232
    ' PCI-1316
    ' PCI-225x
    ' PCI-3xxx

    Sub Main()

        Dim rst As Integer
        Dim DevIndex As Integer = 0
        Dim i As Integer
        Dim WaveData(100) As UInteger

        ' 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        ' 设置数字 I/O 方向
        ' 此处将所有的数字 I/O 通道设置为输出
        ' 由于 PCI-225x/3000/5000 的数字 I/O 可以设置为输入或者输出
        ' 此处全部设置为输入
        ' 其他数字 I/O 不支持设置的型号可以不用设置
        rst = SetDioDir(DevIndex, &H0)
        If (rst < 0) Then Return

        ' 清空 Do 波形 FIFO
        rst = ClearDoFifo(DevIndex)
        If (rst < 0) Then Return

        ' 设置 Do 输出为 n-cycle 模式
        rst = SetDoMode(DevIndex, 1)
        If (rst < 0) Then Return

        ' 设置 Do 输出采样率
        ' 此处设置为 100000ns，即 10kS/s
        rst = SetDoSamplePeriod(DevIndex, 100000)
        If (rst < 0) Then Return

        ' 设置 Do 输出波形次数
        ' 此处输出 10 次。如果设置为 0，表示无限循环输出
        rst = SetDoNCycleCount(DevIndex, 10)
        If (rst < 0) Then Return

        ' 设置 Do 触发源，Do 软件触发
        rst = SetDoTrigSource(DevIndex, 18)
        If (rst < 0) Then Return

        ' 生成 100 点的波形数据
        For i = 0 To 99 Step 1
            WaveData(i) = Rnd() * &HFFFF
        Next i

        ' 设置 Do 波形数据
        ' 将 100 个点的波形数据写入到硬件
        For i = 0 To 99 Step 1
            rst = SetDoFifo(DevIndex, WaveData(i))
            If (rst < 0) Then Return
        Next i

        ' 设置 Do 准备完成，DoReady
        rst = DoReady(DevIndex, 1)
                If (rst < 0) Then Return

        ' 发出 Do 软件触发命令
        rst = SetDoSoftTrig(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("Success.")

        ' 清除 Do 软件触发标志
        rst = ClearDoSoftTrig(DevIndex)
        If (rst < 0) Then Return

        ' 清除 Do 准备完成标志
        rst = DoReady(DevIndex, 0)
        If (rst < 0) Then Return

        ' 关闭设备
        rst = CloseDevice(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
